/*
 * Base layout styles
 */
*
*::before
*::after
    box-sizing border-box
    word-wrap break-word

html
    text-rendering optimizeLegibility
    -webkit-font-smoothing antialiased
    -moz-osx-font-smoothing grayscale

    &[data-focus-source="key"] :focus
        z-index 90
        outline-offset 6px
        outline 2px solid $cl--focus

    :focus
        outline 0

body
.app
    // the below three properties ensure that elements with
    // fixed positioning will still display relative to the viewport
    will-change unset
    transform none
    filter none
    display flex
    flex-direction column
    align-items center
    justify-content flex-start
    min-height 100vh
    width 100vw
    overflow-x hidden

.main_content
    flex 1
    display flex
    flex-direction column
    width 100%

// styles nested in this block are for a standard
// content page layout with a centered containing div
.page_content
    contain(flex)
    flex-direction column
    align-items flex-start

    > *:first-child
        margin-top $sp--plus-half

    > *:last-child
        margin-bottom $sp--plus-half

img
    display block
    height auto
    width auto
    max-width 100%
    vertical-align bottom

svg
    overflow visible // fix bug in Firefox where edges of SVG display as cut
    height 100%
    max-height 100%
    width 100%
    max-width 100%

input
button
    trans()

button
    button-reset()


/*
 * Base typographic styles
 */

body
select
input
textarea
    font-family $ff--body
    font-weight $fw--normal
    line-height $lh--body
    font-size inherit
    letter-spacing $ls--body
    color $cl--light

h1
h2
h3
h4
    display block
    line-height $lh--heading
    font-family $ff--heading
    font-weight $fw--heading
    letter-spacing $ls--heading
    color $cl--med

    a
    a:visited
        color $cl--anchor

        &:active
        &:hover
        &:focus
            color $cl--anchor--interact

h1
    font-family $ff--heading


h2
h3
h4
    font-family $ff--body

h1
    font-size $fz--base * $ratio ** 4

    * + &
        margin-top $fz--base * $lh--heading * $ratio ** 4

h2
    font-size $fz--base * $ratio ** 3

    * + &
        margin-top $fz--base * $lh--heading * $ratio ** 3

h3
    text-transform uppercase
    font-size $fz--base * $ratio ** 2

    * + &
        margin-top $fz--base * $lh--heading * $ratio ** 2

h4
    font-size $fz--base * $ratio

    * + &
        margin-top $fz--base * $lh--heading * $ratio

p
    width auto
    mt()
    max-width 100%
    font-family $ff--body
    font-size $fz--base
    line-height $lh--body
    letter-spacing $ls--body
    color $cl--med

    h1 + &
    h2 + &
    h3 + &
        margin-top $sp--third

    h4 + &
        margin-top $sp--half

    // add this class to paragraph content to constrain it to a readable line-length
    // avoid setting paragraph line-lengths globally so they don't need to be overridden
    .reading_content &
    &.reading_content
        width ($ll)ch

        > a
        > a:visited
            color $cl--anchor

            &:active
            &:hover
            &:focus
                color $cl--anchor--interact

a
a:visited
    trans()
    cursor pointer
    text-decoration none

b
strong
    font-weight 600
    font-family $ff--body

i
em
    font-style italic
    font-family $ff--body

::selection
    background-color $cl--first
    text-shadow 0 0 .1em $cl--first--dark
    color white

.reading_content
    width 100%

    ul
    ol
    dl
        display block
        width 100%
        max-width ($ll)ch
        padding-left 3ch

    & * + ul
    & * + ol
    & * + dl
        margin-top $sp--two-thirds

    ul
        list-style-type disc

    ul ul
        list-style-type circle

    ul ul ul
        list-style-type square

    ol
        list-style-type decimal

    ol ol
        list-style-type lower-alpha

    ol ol ol
        list-style-type lower-roman

    li
        max-width 100%

        ul
        ol

            &:first-child
                margin-top $sp--half

    * + li
        margin-top $sp--half

sup
    vertical-align super
    font-size $fz--base / $ratio
